EDIT - bug #7287

Unit tests using the DefaultTerminitializer break subsequent integration tests in the suite
02/21/2018 06:21 PM - Andreas Kohlbecker
Description

Here we make the distinction between Unit and integration test by the fact that integration tests are sub classing
CdmTransactionallntegrationTest.

A couple of unit test are making use of term, so the terms need to be initialized. This is done in theses tests by ca method like:
@BeforeClass
public static void setUpBeforeClass () throws Exception {
DefaultTermInitializer initializer = new DefaultTermInitializer();
initializer.initialize();
}
This approach is highly problematic:
If an integration test has run before the TestingTerminitializer has already initialized the terms. Calling the initialize() method of the
DefaultTermInitializer will reset and override all terms. This breaks subsequent Integration tests since the TestingTermlInitializer is

only run once per suite.

An interim solution which is not 100% reliable is to check in the setUpBeforeClass()method if the terms already have been loaded.
This method should be in a base class for all tests that use the DefaultTermlnitializer.

As a long term task we should separate Unit and integration tests completely, see #7288
Additional tasks:

e revert DerivedUnitFacadeCacheStrategylnjectionTest, DerivedUnitFacadeCacheStrategyTest,
DerivedUnitFacadeFieldUnitCacheStrategyTest to unit tests, see commented @BeforeClass

Related issues:
Related to EDIT - task #7288: Separate Unit and integration tests completely, New
Related to EDIT - bug #8174: First test fails if term data is in loaded DataSet New

Associated revisions

Revision ec33f269 - 02/22/2018 11:30 AM - Andreas Kohlbecker

ref #7287 base test class for all unit tests which need terms being initialized

Revision 38e6eada - 02/22/2018 12:31 PM - Andreas Kohlbecker
ref #7287 fixing bug

Revision 9a4a2ab7 - 02/22/2018 12:41 PM - Andreas Kohlbecker

ref #7287 reverting DerivedUnitFacade test back to using tests

Revision 6b579e4a - 02/08/2021 04:54 PM - Andreas Miiller

ref #7287 unignore tests on CondensedDistributionComposerBase subclasses

History

#1 - 02/21/2018 06:23 PM - Andreas Kohlbecker

- Description updated
#2 - 02/21/2018 06:23 PM - Andreas Kohlbecker

- Related to task #7288: Separate Unit and integration tests completely, added

#3 - 02/21/2018 06:33 PM - Andreas Kohlbecker

affected test class files (without cdmlib-model, model has no integration tests!):
cdmlib-ext/src/test/java/eu/etaxonomy/cdm/ext/ipni/IpniServiceTest. java
cdmlib-ext/src/test/java/eu/etaxonomy/cdm/ext/geo/EuroPlusMedCondensedDistributionComposerTest. java
cdmlib-ext/src/test/java/eu/etaxonomy/cdm/ext/geo/FloraCubaCondensedDistributionComposerTest. java
cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeCacheStrategyInjectionTest. java
cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeCacheStrategyTest. java

cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeFieldUnitCacheStrategyTest. java
cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/DistributionNodeByArealabelComparatorTest. java

#4 - 02/21/2018 06:39 PM - Andreas Kohlbecker

- Description updated

#5 - 02/22/2018 07:54 AM - Andreas Kohlbecker

- Description updated

#6 - 02/22/2018 07:56 AM - Andreas Kohlbecker

- Description updated

#7 - 02/22/2018 11:19 AM - Andreas Kohlbecker

- Tags set to test

#8 - 02/22/2018 11:41 AM - Andreas Kohlbecker

After using the new unit test base class TermTest for all test which need the terms to be initialized another strange symptom pops up.
... test in cdmlib-persistence are failing now.

The analysis of the cause for this problem reveals that the tests in cdmlib-persistence are failing if they are preceeded by the tests in cdmlib test:
mvn test -pl cdmlib-test,cdmlib-persistence

==> ALL TEST FAIL (Tests run: 436, Failures: 0, Errors: 235, Skipped: 7)

Exception: Could not obtain transaction-synchronized Session for current thread

mvn test -pl cdmlib-persistence

==> SUCCESS

in cdmlib-test there is only one test anyway. But even after disabling this test by annotating the class with @Ignore:

mvn test -pl cdmlib-test,cdmlib-persistence

===> Still ALL TEST ARE FAILING even if no tests are running

#9 - 02/22/2018 12:33 PM - Andreas Kohlbecker

The above mentioned problems where only due to a local change in CdmTransactionallntegrationTest which | applied for testing!

#10 - 02/22/2018 12:44 PM - Andreas Kohlbecker

- Status changed from New to Closed

#11 - 02/22/2018 12:44 PM - Andreas Kohlbecker
- % Done changed from 0 to 100

#12 - 02/08/2021 04:48 PM - Andreas Miiller
- Related to bug #8174: First test fails if term data is in loaded DataSet added

#13 - 02/08/2021 04:49 PM - Andreas Miiller

Andreas Kohlbecker wrote:
After using the new unit test base class TermTest for all test which need the terms to be initialized another strange symptom pops up.

... test in cdmlib-persistence are failing now.

The analysis of the cause for this problem reveals that the tests in cdmlib-persistence are failing if they are preceeded by the tests in cdmlib test:
mvn test -pl cdmlib-test,cdmlib-persistence

==> ALL TEST FAIL (Tests run: 436, Failures: 0, Errors: 235, Skipped: 7)

Exception: Could not obtain transaction-synchronized Session for current thread

mvn test -pl cdmlib-persistence

==> SUCCESS

in cdmlib-test there is only one test anyway. But even after disabling this test by annotating the class with @Ignore:

mvn test -pl cdmlib-test,cdmlib-persistence

===> Still ALL TEST ARE FAILING even if no tests are running

This could be related to #8174
